#include "forms.h"
#include "tyman.h"
#include "dummy.xpm"


#ifndef ICON_DIR 
#define ICON_DIR /usr/include/X11/pixmaps
#endif

extern FD_dialog *fd_dialog;
extern char * icon_place;
extern char * tyopt;

/* callbacks for form dialog */
void X_Coord(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void XPM_Icon(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  const char * pf;

  pf  = fl_get_input(fd_dialog->XPM);
  fl_set_pixmap_data(fd_dialog->icon_display ,dummy_xpm);
  fl_redraw_object(fd_dialog->Frame);
  fl_set_pixmap_file(fd_dialog->icon_display,pf);
}

void Icon_Label(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void Cmd_To_Run(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void Drop_Cmd_To_Run(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}

void Y_Coord(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
}
void View_Icon(void)
{
  char pname[1024];
  sprintf(pname,"%s/%s",fl_get_directory(),fl_get_filename());
  if (pname[strlen(pname)]!='/')
    {
      fl_set_pixmap_data(fd_dialog->icon_display,dummy_xpm);
      fl_redraw_object(fd_dialog->Frame);
      fl_set_pixmap_file(fd_dialog->icon_display,pname);
    }
}

void Browse_Icon(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  const char * pf;

  fl_add_fselector_appbutton("View",View_Icon,NULL);
  pf=fl_show_fselector("Find an icon",
		       icon_place,
		       "*.xpm","");
  fl_remove_fselector_appbutton("View");
  if (pf!=NULL)
    {
      if (strlen(pf)!=0)
	{
	  fl_set_input(fd_dialog->XPM,pf);
	  fl_set_pixmap_data(fd_dialog->icon_display,dummy_xpm);
	  fl_redraw_object(fd_dialog->Frame);
	  fl_set_pixmap_file(fd_dialog->icon_display,pf);
	}
    }
}

void Ok_Pressed(FL_OBJECT *ob, long data)
{
  /* run tycoon here */
  const char * X, *Y;
  const char * icon;
  const char * label;
  const char * cmd;
  const char * drop_cmd;
  int lacking_data;
  char icon_in_cmd[100];

  lacking_data=0;

  X     = fl_get_input(fd_dialog->XCoord);
  Y     = fl_get_input(fd_dialog->YCoord);
  icon  = fl_get_input(fd_dialog->XPM);
  label = fl_get_input(fd_dialog->IconLabel);
  cmd   = fl_get_input(fd_dialog->Cmd);
  drop_cmd=  fl_get_input(fd_dialog->Drop_Cmd);
  
  if (strlen(X)==0)     lacking_data=1;
  if (strlen(Y)==0)     lacking_data=1;
  if (strlen(icon)==0)  lacking_data=1;
  if (strlen(label)==0) lacking_data=1;
  if (strlen(cmd)==0)   lacking_data=1;
  if (strlen(drop_cmd)==0)   drop_cmd="None";
  if (lacking_data) fl_show_alert("Please fill out all the fields","","",1);
  
  if (!lacking_data) 
    {
      sprintf(icon_in_cmd,"tycoon %s %s %s '%s' %s '%s' '%s'",tyopt,X,Y,label,
	      icon,cmd,drop_cmd);
      system(icon_in_cmd);
      exit(0);
    }
}

void Cancel_Pressed(FL_OBJECT *ob, long data)
{
  exit(0);
}



